const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const boms = sequelize.define(
    'boms',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

bom_code: {
        type: DataTypes.TEXT,
      
      

      },

bom_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"engineering",


"manufacturing"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"active",


"inactive"

        ],

      },

effective_from: {
        type: DataTypes.DATE,
      
      

      },

effective_to: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  boms.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














    db.boms.hasMany(db.bom_lines, {
      as: 'bom_lines_bom',
      foreignKey: {
          name: 'bomId',
      },
      constraints: false,
    });























//end loop



    db.boms.belongsTo(db.materials, {
      as: 'parent_material',
      foreignKey: {
        name: 'parent_materialId',
      },
      constraints: false,
    });

    db.boms.belongsTo(db.material_revisions, {
      as: 'revision',
      foreignKey: {
        name: 'revisionId',
      },
      constraints: false,
    });




    db.boms.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.boms.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return boms;
};


